
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Learning_pathsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        goal: data.goal
        ||
        null
            ,
            
        audience: data.audience
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await learning_paths.setOwner( data.owner || null, {
            transaction,
        });
        
        await learning_paths.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        
        await learning_paths.setItems(data.items || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.learning_paths.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: learning_paths.id,
            },
            data.cover_image,
            options,
        );
        

        return learning_paths;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const learning_pathsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                goal: item.goal
            ||
            null
            ,
            
                audience: item.audience
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const learning_paths = await db.learning_paths.bulkCreate(learning_pathsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < learning_paths.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.learning_paths.getTableName(),
                    belongsToColumn: 'cover_image',
                    belongsToId: learning_paths[i].id,
                },
                data[i].cover_image,
                options,
            );
        }
        

        return learning_paths;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const learning_paths = await db.learning_paths.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.goal !== undefined) updatePayload.goal = data.goal;
        
        
        if (data.audience !== undefined) updatePayload.audience = data.audience;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await learning_paths.update(updatePayload, {transaction});

        
        
        if (data.owner !== undefined) {
            await learning_paths.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await learning_paths.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        
        if (data.items !== undefined) {
            await learning_paths.setItems(data.items, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.learning_paths.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: learning_paths.id,
            },
            data.cover_image,
            options,
        );
        

        return learning_paths;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of learning_paths) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of learning_paths) {
                await record.destroy({transaction});
            }
        });


        return learning_paths;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.findByPk(id, options);

        await learning_paths.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await learning_paths.destroy({
            transaction
        });

        return learning_paths;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const learning_paths = await db.learning_paths.findOne(
            { where },
            { transaction },
        );

        if (!learning_paths) {
            return learning_paths;
        }

        const output = learning_paths.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        output.progress_records_path = await learning_paths.getProgress_records_path({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.cover_image = await learning_paths.getCover_image({
            transaction
        });
        
        
        output.owner = await learning_paths.getOwner({
            transaction
        });
        
        
        output.items = await learning_paths.getItems({
            transaction
        });
        
        
        output.organizations = await learning_paths.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },


      {
        model: db.content_items,
        as: 'items',
        required: false,
      },


      {
        model: db.file,
        as: 'cover_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_paths',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.goal) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_paths',
                        'goal',
                        filter.goal,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.audience) {
                where = {
                    ...where,
                audience: filter.audience,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      


      if (filter.items) {
        const searchTerms = filter.items.split('|');

        include = [
          {
            model: db.content_items,
            as: 'items_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  title: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.learning_paths.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'learning_paths',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.learning_paths.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

